set design "combpm"
set top top_combpm_electron
set part "xczu11eg-ffvc1760-2L-e"

set vlnv_vendor "synchrotron-soleil.fr"

set ip_properties [ list \
    vendor ${vlnv_vendor} \
    library "user" \
    name ${design} \
    version "1.0" \
    taxonomy "/Communication_&_Networking/Serial_Interfaces" \
    display_name "BPM Communication Decoder" \
    description "Decode CC protocol (Electron) from a transceiver interface and generate AXIS frames" \
    vendor_display_name "Synchrotron SOLEIL" \
    company_url "http://www.synchrotron-soleil.fr" \
    ]

set family_lifecycle [list \
  zynquplus{${part}} Beta \
]
